require "csvgem/version"
require 'spreadsheet'
require 'active_record'

class ActiveRecord::Base
  def self.to_xls(*attributes)
    book = Spreadsheet::Workbook.new
    Csvgem.insert_columns(book, self, attributes)
    book.write "./#{self.to_s.pluralize}.xls"
  end
end

module Csvgem
  def self.insert_columns(book, model, attributes = [])
    attributes = model.column_names if attributes.empty?
    sheet = book.create_worksheet(name: model.to_s.pluralize)
    attributes.each { |attribute| sheet.row(0).push(attribute) }
    model.all.each_with_index do |column, index|
      attributes.each do |attribute|
        sheet.row(index+1).push(column.attributes[attribute])
      end
    end
  end

  def self.to_xls(*models)
    book = Spreadsheet::Workbook.new
    models.each do |model|
      Csvgem.insert_columns(book, model)
    end
    book.write "./records.xls"
  end
end
